package mako5.ctrl;


import mako5.gfx.Render;
import mako5.evnt.RealTime;

/**
 * A game state that is capable of rendering and handling input.
 * 
 * @author Paul Jarrett
 * @version 28-Sept 2005
 */

public class GameState implements Render, RealTime {

	private GameStateMachine m_rCallingMachine; // machine in charge of this



	// game state

	/**
	 * Makes a new blank game state.
	 */
	public GameState() {
	}



	/**
	 * Returns the calling machine.
	 */
	public GameStateMachine getMachine() {
		return m_rCallingMachine;
	}



	/**
	 * Sets the calling machine
	 */
	public void setMachine(GameStateMachine m) {
		m_rCallingMachine = m;
	}



	/**
	 * Renders this state.
	 */
	public void render() {
	}



	/**
	 * Refreshes this state from the current stored game data in its calling
	 * machine.
	 */
	public void refresh() {
	}



	/**
	 * Stores information in the game data map.
	 */
	public void store() {
	}



	/**
	 * Updates this state.
	 */
	public void update(float t) {
	}



	/**
	 * Cleans up after this state.
	 */
	public void cleanup() {
	}



	/**
	 * Exits the program.
	 */
	public void exit() {
		getMachine().exit();
	}
}