package mako5.evnt;


/**
 * An object that can be put into a group for real time operations such as
 * physics, rendering, and general logic updates.
 * 
 * This allows the system to check to see when the object needs to be removed,
 * so that it can be from these operations.
 * 
 * @author Paul Jarrett
 * @version 07-Mar 2006
 */

public interface Controller {

	/**
	 * Indicates that this object is targeted for complete removal by the
	 * system.
	 * 
	 * @since 07-Mar 2006
	 */
	boolean needsRemoval();
}