package mako5.evnt;


/**
 * This class is useful for time benchmarking. It marks a start time and end
 * time, and then reports the elapsed time between start and finish.
 * 
 * @author Paul Jarrett
 * @since 07-Jul 2006
 * @version 07-Jul 2006
 */

public class StopWatch {

	/**
	 * The start time for the watch.
	 * 
	 * @since 07-Jul 2006
	 */
	private long start;

	/**
	 * The end time for the watch.
	 * 
	 * @since 07-Jul 2006
	 */
	private long end;



	/**
	 * Makes a new StopWatch.
	 * 
	 * @since 07-Jul 2006
	 */
	public StopWatch() {
		start = System.currentTimeMillis();
		end = System.currentTimeMillis();
	}



	/**
	 * Resets the starting time to now.
	 * 
	 * @since 07-Jul 2006
	 */
	public void reset() {
		start = System.currentTimeMillis();
	}



	/**
	 * Marks the next end time and returns the elapsed time.
	 * 
	 * @since 07-Jul 2006
	 */
	public long mark() {
		end = System.currentTimeMillis();
		return end - start;
	}
}