package mako5.math.phys;


/**
 * Any object that has collision bounds.
 * 
 * @author Paul Jarrett
 * @version 19-Feb 2006
 */

public interface Bounded {

	/**
	 * Returns the bounds of this object
	 * 
	 * @since 08-Mar 2006
	 */
	abstract public Bounds getBounds();



	/**
	 * Notifies this object of the collision.
	 * 
	 * @since 29-Mar 2006
	 */
	abstract public void notifyCollision(Bounded other);
}