package mako5.util;


import java.util.List;

/**
 * Makes a new queue.
 * 
 * @author Paul Jarrett
 * @version 2-Feb 2006
 * @version 05-Apr 2006, placed under Queue<T> interface
 * @see Queue
 */

public final class ListQueue<T> implements Queue<T> {

	private List<T> m_rList;



	/**
	 * Makes a new ListQueue with the given type of list. Stores info in the
	 * list passed to us.
	 */
	public ListQueue(List<T> rAlias_) {
		m_rList = rAlias_;
	}



	/**
	 * 
	 * Dequeues this queue
	 * 
	 */
	public T dequeue() {
		return m_rList.remove(0);
	}



	/**
	 * 
	 * Enqueues this queue
	 * 
	 */
	public void enqueue(T rObj) {
		m_rList.add(rObj);
	}



	/**
	 * Returns true if there are no more elements in this
	 * 
	 */
	public boolean isEmpty() {
		return m_rList.isEmpty();
	}



	/**
	 * 
	 * Removes all elements from this queue
	 */
	public void clear() {
		m_rList.clear();
	}



	/**
	 * Returns the number of elements in this.
	 */
	public int size() {
		return m_rList.size();
	}

}