package mako5.util;


/**
 * A queue interface.
 * 
 * @author Paul Jarrett
 * @version 2-Feb 2006
 * @version 24-May 2006
 * 
 */

public interface Queue<T> {

	/**
	 * Dequeues this queue.
	 * 
	 * @return the next object from this queue
	 * @since 24-May 2006
	 */
	T dequeue();



	/**
	 * Enqueues this queue.
	 * 
	 * @param rObj
	 *            the object to add to the queue
	 * @since 24-May 2006
	 */
	void enqueue(T rObj);



	/**
	 * Returns true if there are no more elements in this.
	 * 
	 * @return true if this queue is empty
	 * @since 24-May 2006
	 */
	boolean isEmpty();



	/**
	 * Removes all elements from this queue.
	 * 
	 * @since 24-May 2006
	 */
	void clear();



	/**
	 * Returns the number of elements in this.
	 * 
	 * @return the number of elements in the queue
	 * @since 24-May 2006
	 */
	int size();
}