package mako5.util;


/**
 * A stack interface.
 * 
 * @author Paul Jarrett
 * @version 29-Jun 2006
 */

public interface Stack<T> {

	/**
	 * Pushes an element into the stack.
	 * 
	 * @param rVal_
	 *            the element to add into the stack
	 * @since 14-Mar 2006
	 * @since 24-Mar 2006 (1.00)
	 */
	void push(T rVal_);



	/**
	 * Pops an element from this stack.
	 * 
	 * @return the popped element from this stack
	 * @since 14-Mar 2006
	 * @since 24-Mar 2006 (1.00)
	 */
	T pop();



	/**
	 * Returns true if this stack is empty.
	 * 
	 * @return true if this stack is empty.
	 * @since 14-Mar 2006
	 * @since 24-Mar 2006 (1.00)
	 */
	boolean isEmpty();



	/**
	 * Returns the current number of elements in this stack.
	 * 
	 * @return the number of elements in the stack.
	 * @since 14-Mar 2006
	 */
	int size();
}